



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【SqlServer】聚集索引与主键、非聚集索引</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【SqlServer】聚集索引与主键、非聚集索引</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 22:19:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>目录结构：</p>
<div>contents structure [-]</div>
<div>
<ol><li><a href="#a1" rel="external nofollow noreferrer">聚集索引和非聚集索引的区别</a></li>
<li><a href="#a2" rel="external nofollow noreferrer">聚集索引和主键的区别</a></li>
<li><a href="#a3" rel="external nofollow noreferrer">主键和(非)聚集索引的常规操作</a></li></ol>
</div>
<p>聚集索引、非聚集索引在SqlServer、MySQL、Oracle...等数据库中都有这个概念，只不过在SqlServer中叫做聚集索引和非聚集索引而已。下面笔者将会以SqlServer数据库来讲解。</p>
<h1>1.聚集索引和非聚集索引的区别</h1>
<p>聚集索引：该索引中键值的逻辑顺序决定了表中相应行的物理顺序。<br />非聚集索引：该索引中索引的逻辑顺序与磁盘上行的物理存储顺序不同。<br />索引是通过二叉树的数据结构来描述的，我们可以这么理解聚集索引：索引的叶节点就是数据节点。而非聚集索引的叶节点仍然是索引节点，只不过有一个指针指向对应的数据块。<br />看下图</p>
<p>聚集索引：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1070689/201802/1070689-20180225000658108-1243568181.jpg" /></p>
<p>通过这张图片可以看出，数据库的数据是按照某一顺序排列好的，而叶子节点就是真实的数据节点。</p>
<p>非聚集索引：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1070689/201802/1070689-20180225000818270-966368620.jpg" /></p>
<p>通过这张非聚集索引的图片，我们也可以看出，叶子节点也是数据节点，只不过该节点并非真实的数据节点，该节点存储的是真实数据的内存地址。</p>
<p>下面是一张何时使用聚集索引和非聚集索引的表：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1070689/201802/1070689-20180225002821127-880597520.png" /></p>
<p>通过上面的图，相信对聚集索引和非聚集索引有了一定的概念了。接来下举个实例，假如有一张500万条数据的消息表，id是主键（13位随机数）,time是数据的添加日期，现在需要查询2两年内的所有数据，这很显而易见应该给time添加聚集索引，因为查询的条件为 where time 。所以应该给time添加添加聚集索引，如果是这样的情况，笔者建议最好再给表添加一个idate字段，idate存储当前时间的毫秒数，字段的类型不建议为varchar，最好为int，若int装不下可以设置为numeric，因为int的查询效率要比varchar的效率高。</p>
<h1>2.聚集索引和主键的区别</h1>
<p>笔者在网上看见有人提出，主键就是加了唯一性约束的聚集索引，这句话不全对。</p>
<p>主键的定义：&ldquo;主键指的是一个列或多列的组合，其值能唯一地标识表中的每一行，通过它可强制表的实体完整性。&rdquo;<br />在SqlServer中，创建主键的列，默认添加一个聚集索引。主键不仅可以关联聚集索引，还可以关联非聚集索引。因此只能说主键和索引有关系。</p>
<p>但是需要明白，主键和索引的作用是不一样的，主键的作用是为了唯一标识表中的某一行，而索引的作用是为了提高查询效率。SqlServer默认给主键列添加聚集索引，这在某些情况下就显得比较浪费，在实际情况中，我们一般都会给ID设置为主键，如果ID是随机产生的，那么这个时候给ID再设置上聚集索引就有点浪费了，原因有二，第一，一般情况不会再按照ID查询区间值数据了，第二，一个表中只能有一个聚集索引，所以聚集索引比较珍贵，要尽可能的发挥聚集索引的最大值。</p>
<h1>3.主键和(非)聚集索引的常规操作</h1>
<div>
<p>-- 排序(聚集索引)</p>
<div>
<pre class="prettyprint linenums">create clustered index inx_entry_stock_bi on entry_stock_d(entry_stock_bi)</pre>
</div>
<p>-- 创建非聚集索引</p>
<div>
<pre class="prettyprint linenums">create nonclustered index inx_entry_stock on entry_stock_d(entry_stock_bi)</pre>
</div>
<p>-- 主键</p>
<div>
<pre class="prettyprint linenums">alter table entry_stock_d add primary key nonclustered--主键且非聚集<br />
(<br />
 entry_stock_bi,aid<br />
)</pre>
</div>
<p>-- 删除主键或索引</p>
<div>
<pre class="prettyprint linenums">alter table table_name drop constraint name</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390p7v38.html">swift 构建类</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pv6ny9.html">Ajax讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mne122q.html">DuiLib&mdash;&mdash;第二篇UIBase</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wme6wq.html">HDU 4284Travel（状压DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmzkee9.html">HotSpot算法实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kv0629.html">hdu&lowbar;5036&lowbar;Explosion&lpar;bitset优化传递闭包&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljopx19.html">mongodb启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k0vd69.html">Import Excel void &lpar;NPOI&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2eynpq.html">SVM-sklearn</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlloexxq.html">Centos7安装Tomcat8</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25xvp3q.html">JarvisOJ Misc 炫酷的战队logo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwgokj9.html">leetcode python 007</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd61ld9.html">&amp;quot&semi;Native table &amp;&num;39&semi;performance&lowbar;schema&amp;&num;39&semi;&period;&amp;&num;39&semi;session&lowbar;variables&amp;&num;39&semi; has the wrong structure&amp;quot&semi;&rpar; &lbrack;SQL&colon; &amp;quot&semi;SHOW VARIABLES LIKE &amp;&num;39&semi;sql&lowbar;mode&amp;&num;39&semi;&amp;quot&semi;&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyynrz2q.html">&lbrack;BZOJ5427&rsqb;最长上升子序列&sol;&lbrack;BZOJ4282&rsqb;慎二的随机数列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwyokx9.html">学习笔记21&mdash;PS换图片背景</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w5rxgq.html">Scala深入浅出实战经典：29&comma;Case class和Case object代码实战解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2nr4e8.html">更改jupyter notebook的主题颜色&lpar;theme&rpar; 包括pycharm</a>
		</li>
						<li><a href="https://www.batexi.com/a/9630xny9.html">nginx 前端调度 对后端的app的生存状态的检测</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4427eq.html">自然语言交流系统 phxnet团队 创新实训 项目博客 （三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44gkd0q.html">java中内存泄露和内存溢出</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zkod0v8.html">配置windows失败，不能进入系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlj65r9.html">单例模式在生产环境jedis集群中的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kjr1lq.html">在Ubuntu系统上搭建Hadoop 2&period;x&lpar;2&period;6&period;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppdzly9.html">MVC 之 缓存机制（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vkgm6q.html">【树莓派】树莓派新版系统SSH连接被拒绝问题处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kj71vq.html">NetCore的控制台应用中搭建WebServer的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/902mwgmq.html">Linux（CentOS）中使用Mono&plus;jexus部署Asp&period;net4&period;5网站</a>
			</li>
						<li><a href="https://www.batexi.com/a/953grk08.html">SQL Server时间戳</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em4evm9.html">SLF4J warning or error messages and their meanings</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vrrv6q.html">Oracle NET工作原理、配置及连接问题排查</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
